#include "mopcapi.h"
#include <stdio.h>
#include "grade.h"
#include "rpmpldi.h"
#include "module.h"
 /* #include "server/server_db.h"
  */ 
#include "net.h"
#include "mess.h"
#include "cfile.h"
#include "bug.h"

static int sock;

static void die(const char *msg)
{
	fprintf(stderr, "Fatal error: %s\n", msg);
	exit(2);
}

/** email1 -- logowanie
 *  email2 -- dodawnie urrytkownika 
 */
int login(char *email1 ,char *name,char *nick,char *email2,int expLevel,char *pass)
{
	struct phash *pkt;
	struct pkt_entry *e;
	int ret;
	char md5[33], *buf;
	
	sock = inet_connect(getMopHost(),getMopPort());
	if (sock < 0)
		die("can't connect");

	pkt = ph_new();
	pkt_add_string(pkt, "type", "version");
	pkt_add_int(pkt, "version", 1);

	pkt_send(sock, pkt);

	pkt = pkt_recv(sock);

	if (pkt == 0)
		die("connection lost");

	e = ph_find(pkt, "cookie");
	if (e == 0)
		die("no cookie -- no fun :)");
		
	printf("got cookie: %s\n", e->string);
		
	buf = ymalloc(strlen(e->string) + strlen(pass) + 1);
	strcpy(buf, e->string);
	strcat(buf, pass);
	pkt_md5(buf, md5);

	/* FIXME: check if version match */
	pkt_free(pkt);

	pkt = ph_new();
	
	if (email1 == NULL) {
		pkt_add_string(pkt, "type", "register_user");
		pkt_add_string(pkt,"nick",nick);
		pkt_add_string(pkt, "name",name);
		pkt_add_string(pkt, "email",email2);
		pkt_add_string(pkt, "password",pass);
		pkt_add_int   (pkt, "experience_level",expLevel);
		setMopEmail(email2);
	} else {
		pkt_add_string(pkt, "type", "login");
		pkt_add_string(pkt, "email",email1); 
		pkt_add_string(pkt, "md5", md5);
		setMopEmail(email1);
	}
	
	pkt_send(sock, pkt);

	pkt = pkt_recv(sock);
	if (pkt == 0)
		die("connection lost");

	e = ph_find(pkt, "greet");
	if (e == 0)
		die("no greet");
	/* FIXME: it shoulden't be just printfed (what if there is some
	 * "advenced" UI ?)
	 * then we shall get messagebox :) but right this shall not
	 * be interactive :) */
	printf("%s\n", e->string);
	
	if ((e = ph_find(pkt, "user_no")))
		ret=e->number;
	else
		ret=0;
	pkt_free(pkt);
	return ret;
}

Tgrade* receiveReport(TpkgDescribe *pk, int *grCount)
{
	struct phash *pkt, *snd;
	struct pkt_entry *e;	
	int i;
	Tgrade *ret = NULL;

	snd=ph_new();
	pkt_add_string(snd,"type","get_report");
	pkt_add_string(snd, "name", pk->name);
	pkt_add_string(snd, "evr", pk->evr);
	pkt_add_string(snd, "arch", pk->arch);
	pkt_send(sock, snd);

	pkt = pkt_recv(sock);
	if (pkt == 0)
		die("connection lost");
	e=ph_find(pkt,"grades_no");
	if(!e)
		die("no name ?");
	*grCount = e->number;
	if(*grCount == 0)
		return NULL;
	ret = (Tgrade *) malloc(sizeof(Tgrade ) * (*grCount));
	for(i=0; i< *grCount; i++){
		char bufFeat[100], bufGrade[100];
		sprintf(bufFeat,"feature_no_%d",i);
		sprintf(bufGrade, "grade_%d",i);
		e = ph_find(pkt, bufFeat);
		if(!e)
			die("no feature no");
		ret[i].featureNo = e->number;
		e = ph_find(pkt, bufGrade);
		if(!e)
			die("no grade");
		ret[i].grade = e->number;
		ret[i].comment = NULL;
	}
	pkt_free(pkt);
	return ret;
}


void sendReport(TpkgDescribe *pk,TpkgDescribe *env,int envCount,
		Tgrade *grades,int grCount)
{
	
	struct phash *pkt, *snd;
	int i;
	char buf[100];

	snd = ph_new();
	pkt_add_string(snd, "type", "add_report");
	pkt_add_string(snd, "name", pk->name);
	pkt_add_string(snd, "evr", pk->evr);
	pkt_add_string(snd, "arch", pk->arch);
	pkt_add_int(snd, "env_no", envCount);
	pkt_add_int(snd, "grades_no", grCount);

	for (i = 0; i < envCount; i++) {
		sprintf(buf, "name_%d", i);
		pkt_add_string(snd, buf, env[i].name);
		sprintf(buf, "evr_%d", i);
		pkt_add_string(snd, buf, env[i].evr);
		sprintf(buf, "arch_%d", i);
		pkt_add_string(snd, buf, env[i].arch);
	}

	for (i = 0; i < grCount; i++) {
		sprintf(buf, "feature_no_%d", i);
		pkt_add_int(snd, buf, grades[i].featureNo);
		sprintf(buf, "grade_%d", i);
		pkt_add_int(snd, buf, grades[i].grade);
		/*if(grades[i].comment){
			sprintf(buf,"comment_%",i);
			pkt_add_int(snd,buf,grades[i].comment);
		}*/
	}

	pkt_send(sock, snd);

	pkt = pkt_recv(sock);
	if (pkt == 0)
		die("connection lost");
	pkt_free(pkt);
}

int getMaxFeatureID()
{
	struct phash *pkt;
	struct pkt_entry *e;	

	pkt = ph_new();
	pkt_add_string(pkt, "type", "get_max_feature_id");

	pkt_send(sock, pkt);

	pkt = pkt_recv(sock);
	if (pkt == 0)
		die("connection lost");

	e = ph_find(pkt, "max_feature_id");
	if (e == 0)
		die("no no");
	return e->number;
}


char *getFeature(int ID)
{
	struct phash *pkt;
	struct pkt_entry *e;
	char *ret;
	
	pkt = ph_new();
	pkt_add_string(pkt, "type", "get_feature_name");
	pkt_add_int   (pkt, "id", ID);
	pkt_send(sock,pkt);
	pkt=pkt_recv(sock);
	if(!pkt)
		die("connection lost");
	e=ph_find(pkt,"name");
	if(!e)
		die("no name ?");
	ret=strdup(e->string);
	pkt_free(pkt);
	return ret;
}
	

void addFeature(char *name)
{

	struct phash *pkt;
	pkt = ph_new();
	pkt_add_string(pkt, "type", "add_new_feature");
	pkt_add_string(pkt, "description", name);
	pkt_send(sock,pkt);
	pkt=pkt_recv(sock);
	if(!pkt)
		die("connection lost");
	pkt_free(pkt);
}

void addFeatureToPackage(char *pkg,int feature)
{
	struct phash *pkt;
	pkt = ph_new();
	pkt_add_string(pkt, "type", "add_feature_to_package");
	pkt_add_int(pkt, "feature_no", feature);
	pkt_add_string(pkt, "package_name",pkg);

	pkt_send(sock, pkt);

	pkt = pkt_recv(sock);

	if (pkt == 0)
		die("connection lost");

	pkt_free(pkt);
}

int* getPackageFeatures(char *pkg)
{
	struct phash *pkt;
	int count, *ret;
	struct pkt_entry *e;
	char buf[100];
	int i;
	
	pkt = ph_new();
	pkt_add_string(pkt, "type", "get_package_features");
	pkt_add_string(pkt, "name", pkg);

	pkt_send(sock,pkt);

	pkt=pkt_recv(sock);

	if(!pkt)
		die("connection lost");
	
	e=ph_find(pkt, "no");
	if(!e)
		die("no no");
	count=e->number;
	ret=malloc(sizeof(int)*(count +1));
	for(i=0;i<count;i++){
		snprintf(buf,99,"feature_%d",i);
		e=ph_find(pkt,buf);
		if(!e)
			die("content error");
		ret[i]=e->number;
	}
	ret[count]=0;
	pkt_free(pkt);
	return ret;
}
		
int getFeatureID(char *name)
{
	struct phash *pkt;
	struct pkt_entry *e;
	int ret;

	pkt = ph_new();
	pkt_add_string(pkt, "type", "get_feature");
	pkt_add_string(pkt, "name", name);
	pkt_send(sock,pkt);
	pkt=pkt_recv(sock);
	if(!pkt)
		die("conection lost");
	e=ph_find(pkt,"id");
	if(!e)
		die("protocol error");
	ret=e->number;
	pkt_free(pkt);
	return ret;
}

char **getList(int *count, int **id, char *table)
{
	struct phash *pkt;
	struct pkt_entry *e;
	char **ret;
	int i;
	char buf[100];
	sprintf(buf,"get_%s",table);

	pkt = ph_new();
	pkt_add_string(pkt,"type",buf);
	pkt_send(sock,pkt);
	pkt = pkt_recv(sock);
	if(!pkt)
		die("connection lost");
	e = ph_find(pkt, "no");
	if(!e)
		die("protocol error");
	*count = e->number;	
	
	ret=malloc(sizeof(char *) *((*count +1) ));
	*id = malloc(sizeof(int) * ((*count +1) ));
	for(i=0;i< *count;i++){
		snprintf(buf,99,"name_%d",i);
		e=ph_find(pkt,buf);
		assert(e);
		ret[i] = strdup(e->string);
		snprintf(buf,99,"id_%d",i);
		e=ph_find(pkt,buf);
		assert(e);
		(*id)[i]=e->number;
	}
	pkt_free(pkt);
	return ret;
}

	

char **getDists(int *count, int**id)
{
	return getList(count,id,"dists");
}

char **getCathegory(int *count, int **id)
{
	return getList(count,id,"cathegory");
}

void sendBugReport(Tbug *bug)
{	
	struct phash *pkt;

	pkt = ph_new();
	pkt_add_string(pkt,"type","add_bug_report");
	pkt_add_string(pkt,"pkg",bug->pkg);
	pkt_add_string(pkt,"evr",bug->evr);
	pkt_add_string(pkt,"title",bug->title);
	pkt_add_string(pkt,"text",bug->text);
	pkt_add_string(pkt,"automatic",bug->automatic);
	pkt_add_int(pkt,"cid",bug->cathegory);
	
	pkt_send(sock,pkt);
	pkt = pkt_recv(sock);
	if(!pkt)
		die("connection lost");
}



char **getPackagesFromDist(int *count, int id )
{	
	struct phash *pkt;
	struct pkt_entry *e;
	char **ret;
	int i, retCount;
	char buf[100];

	pkt= ph_new();
	pkt_add_string(pkt, "type", "get_packages_from_dist");
	pkt_add_int(pkt,"dist_id",id);
	pkt_send(sock,pkt);
	pkt=pkt_recv(sock);
	if(!pkt)
		die("connection lost");
	e=ph_find(pkt,"no");
	if(!e)
		die("protocol error");
	*count=e->number;
	ret=malloc(sizeof(char *) *((*count +1) ));
	retCount = 0;
	for(i=0;i< *count;i++){
		char *evr, *name;
		snprintf(buf,99,"package_%d",i);
		e=ph_find(pkt,buf);
		assert(e);
		name=strdup(e->string);	
		snprintf(buf,99,"evr_%d",i);
		e=ph_find(pkt,buf);
		assert(e);
		evr=strdup(e->string);
log_message("JEST JAKIS PAKIET (%s,%s)\n",name,evr);
		if(rpmpldi_is_installed(name,evr)){
log_message("NAWET JEST ZAINSTALOWANY\n");
			ret[retCount++]=name;
		}
	}
	*count  = retCount;
	pkt_free(pkt);
	
	return ret;


}

char **getPackagesForStatistic(char *pkg,int *count)
{
	struct phash *pkt;
	struct pkt_entry *e;
	char **ret;
	int i;
	char buf[100];

	pkt= ph_new();
	pkt_add_string(pkt, "type", "get_packages_for_statistic");
	pkt_add_string(pkt,"name",pkg);
	pkt_send(sock,pkt);
	pkt=pkt_recv(sock);
	if(!pkt)
		die("connection lost");
	e=ph_find(pkt,"no");
	if(!e)
		die("protocol error");
	*count=e->number;
	ret=malloc(sizeof(char *) *((*count) +1));
	for(i=0;i< *count;i++){
		snprintf(buf,99,"package_%d",i);
		e=ph_find(pkt,buf);
		assert(e);
		ret[i]=strdup(e->string);
	}
	ret[*count]=NULL;
	pkt_free(pkt);
	
	return ret;
}
void getStatistic(TpkgDescribe *pk,TpkgDescribe *env,int envCount)
{
	/*TODO: move all UI stuff to grade.c !!! */
	struct phash *pkt;
	int i,s;
	char buf[100];
	int *features,*f;
	struct pkt_entry *e;
	FILE *fd=NULL;
	
	

	features=getPackageFeatures(pk->name);

	pkt = ph_new();
	pkt_add_string(pkt, "type", "get_statistic");
	pkt_add_string(pkt, "package_name", pk->name);
	pkt_add_string(pkt, "package_evr", pk->evr);
	pkt_add_string(pkt, "package_arch", pk->arch);
	pkt_add_int(pkt, "env_no", envCount);

	for (i = 0; i < envCount; i++) {
		sprintf(buf, "enviroment_name_%d", i);
		pkt_add_string(pkt, buf, env[i].name);
		sprintf(buf, "enviroment_evr_%d", i);
		pkt_add_string(pkt, buf, env[i].evr);
		sprintf(buf, "enviroment_arch_%d", i);
		pkt_add_string(pkt, buf, env[i].arch);
	}
	pkt_send(sock,pkt);
	pkt=pkt_recv(sock);
	if(!pkt)
		die("connection lost");
		
		
	if(getPager()){
		fd=popen(getPager(),"w");
		if(!fd)
			printf("can't open pager: %s !\n",getPager());
	}
	if(!fd)
		fd=stdout;

	fprintf(fd,"\n\n==============\nFormat danych jest nastepujacy \n");
	fprintf(fd,"nazwa pakietu ze srodowiska ||<oceny>||<oceny>||<oceny>\n");
	fprintf(fd,"pierwsze oceny: raporty z danym pakietem starszym; drugie\n oceny -- pakiet w tej samej wersji;\n trzecie oceny -- ocena z raportu z danym pakietem nowszym\n");
	fprintf(fd,"<oceny> to 4 liczby okreslajace ile bylo ocen (w kolejnosci):\n");
	fprintf(fd,"<nie dziala> <prawie nie dziala> <prawie dziala> <dziala>\n");
	fprintf(fd,"Oceny \"nie wiem\" nie sa uwzgledniane\n\n");
	for(f=features;*f;f++){
		fprintf(fd, "\n+Wlasnosc ,,%s'' [%d]\n",getFeature(*f),*f);
		for(i = 0; i < envCount; i++){
			fprintf(fd,"Env %s\t: ",env[i].name);
			for(s=0;s<12;s++){
				sprintf(buf,"mark_%d_%d_%d",*f,i,s);
				e=ph_find(pkt,buf);
				if((s%4)==0)
					fprintf(fd,"||");
				fprintf(fd," %d ",e->number);
				
			}
			fprintf(fd,"\n");
		}
	}
	
	pkt_free(pkt);
	if(fd!=stdout)
		pclose(fd);
}

char **getMachines(int *count, int **id)
{
	return getList(count,id,"machines");
}

/**TODO*/
int setMachine(char *name)
{
	struct phash *pkt;
	pkt = ph_new();
	pkt_add_string(pkt, "type", "set_machine");
	pkt_add_string(pkt, "name", name);
	pkt_send(sock,pkt);
	pkt=pkt_recv(sock);
	if(!pkt)
		die("conection lost");
	return 1;
}
void addMachine(char *name)
{
	struct phash *pkt;
	pkt = ph_new();
	pkt_add_string(pkt, "type", "register_machine");
	pkt_add_string(pkt, "name", name);
	pkt_send(sock,pkt);
	pkt=pkt_recv(sock);
	if(!pkt)
		die("conection lost");
};
